#include <fstream>
#include <iostream>
#define DIMN 100010
#define DIMK 100010
using namespace std;

int f[DIMK];
int v[DIMN];
int c[12];
long long sol;
int n, k;
int getCode(int x) {
    int t = 0, minim = 9;
    while (x) {
        c[++t] = x%10;
        x /= 10;
        if (c[t] < minim)
            minim = c[t];
    }
    int r = 0;
    for (int i=t;i>=1;i--)
        r = r * 10 + (c[i] - minim);
    return r;
}

int getReverse(int code, int k) {
    int t = 0, aux = code, maxim = 0;
   for (int i=1;i<=k;i++){
        c[++t] = aux%10;
        aux /= 10;
        maxim = max(maxim, c[t]);
    }
    int r = 0;
    for (int i = t; i>=1; i--) {
        r = r * 10 + (maxim - c[i]);
    }
    return r;
}

int numar(int n) {
    int s = 0;
    while (n) {
        s++;
        n /= 10;
    }
    return s;
}

int main () {

    ifstream fin ("puzzle.in");
    ofstream fout("puzzle.out");
    int aux;
    fin>>n;
    for (int i=1;i<=n;i++) {
        fin>>v[i];
        if (i == 1)
            k = numar(v[i]);
        f[aux = getCode(v[i])]++;
        //cout<<v[i]<<" "<<aux<<" "<<getReverse(aux, k)<<"\n";
    }

    sol = 0;
    for (int i=1;i<=100000;i++)
        sol += f[i] * 1LL * f[ getReverse(i, k) ];

    sol /= 2;

    sol += f[0] * 1LL * (f[0] - 1) / 2;

    fout<<sol<<"\n";
    return 0;
}
