/*
    Solutie O(n^3)
    prof. Constantin Galatan
*/
#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("fadema.in");
ofstream fout("fadema.out");

const int MaxN = 1001;
short a[MaxN][MaxN];
short L[MaxN];
int n, m;
int nmax;

int main()
{
    fin >> n >> m;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            fin >> a[i][j];

    for (int i = 0; i < m; i++)
    {
        for (int j = i; j < m; j++)
            if (j == i)
                for (int k = 0; k < n; k++)
                    L[k] = a[k][i];
            else
            {
                for (int k = 0; k < n; k++)
                    if (a[k][j] == a[k][j - 1] )
                        L[k] = 2;

                int hmax = 0, h = 0;
                for (int k = 0; k < n; k++)
                {
                    if ( L[k] == 2 )
                        h = 0;
                    else
                    {
                        if ( h > 0 && L[k - 1] != L[k] )
                            h++;
                        else
                            h = 1;
                    }

                    hmax = max(hmax, h);
                }

                nmax = max(nmax, hmax * (j - i + 1));
            }
    }

    fout << nmax;
    fin.close();
    fout.close();
}
