// O(Q + N ^ 2)

#include<stdio.h>
#include<algorithm>
using namespace std;

#define NMAX 3005
#define x first
#define y second

int n, m, height[NMAX], matrix[NMAX][NMAX];
int partial_sums[NMAX][NMAX], q;
pair<int,int> downL, topR;

int main () {

    freopen("tnia.in","r",stdin);
    freopen("tnia.out","w",stdout);

    scanf("%d%d",&n,&m);
    for(int i = 1; i <= n; i++) {
        scanf("%d",&height[i]);
        for(int j = 1; j <= height[i]; j++) {
            matrix[i][j] = 1;
        }
    }

    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++) {
            partial_sums[i][j] = partial_sums[i - 1][j] + partial_sums[i][j - 1] - partial_sums[i - 1][j - 1] + matrix[i][j];
        }

    scanf("%d",&q);
    for(int i = 1; i <= q; i++) {
        scanf("%d%d%d%d", &downL.x, &downL.y, &topR.x, &topR.y);

        printf("%d\n", partial_sums[topR.x][topR.y] - partial_sums[downL.x - 1][topR.y] - partial_sums[topR.x][downL.y - 1]
                       + partial_sums[downL.x - 1][downL.y - 1]);
    }

    return 0;
}
