
const Nmax = 102;
      Cmax = Nmax*Nmax;
      InFile  = 'castel.in';
      OutFile = 'castel.out';

type Mat = array[0..Nmax,0..Nmax] of integer;
	 Vec = array[1..Cmax] of integer;

var A, Viz: Mat;
    N, C : integer;
    i, j, k:integer;
    Slin, Scol: Vec;
    Svf, s_lin, s_col, elin, ecol, Aria:integer;
    maxil, maxic, maxfl, maxfc, AriaMax, NrCamere:integer;
    Fin, Fou: text;


function ValBit(No, Pos: integer):integer;
begin
	ValBit:= ((1 shl Pos) and No) shr Pos;
end;

procedure Fill(lin, col: integer;var Aria, elin, ecol:integer);
var
    i, j:integer;
    Clin, Ccol: Vec;
    CrrLin, CrrCol, Prim, Ultim:integer;
begin
    Aria := 0;
    elin := lin; ecol := col;
    Prim := 1; Ultim := 1; Clin[Ultim] := lin; Ccol[Ultim] := col;
    while(Prim <= Ultim) do begin
        CrrLin := Clin[Prim]; CrrCol := Ccol[Prim]; inc(Prim);
        Viz[CrrLin][CrrCol] := 1;
        inc(Aria);
        if(elin<=CrrLin) and (ecol<=CrrCol) then begin elin := CrrLin; ecol := CrrCol; end;
        if(ValBit(A[CrrLin][CrrCol], 3)=0) and (Viz[CrrLin-1][CrrCol]=0) then
            begin inc(Ultim); Clin[Ultim] := CrrLin-1; Ccol[Ultim] := CrrCol; Viz[CrrLin-1][CrrCol] := 1; end;
        if(ValBit(A[CrrLin][CrrCol], 2)=0) and (Viz[CrrLin][CrrCol+1]=0) then
            begin inc(Ultim); Clin[Ultim] := CrrLin; Ccol[Ultim] := CrrCol+1; Viz[CrrLin][CrrCol+1] := 1; end;
        if(ValBit(A[CrrLin][CrrCol], 1)=0) and (Viz[CrrLin+1][CrrCol]=0) then
            begin inc(Ultim); Clin[Ultim] := CrrLin+1; Ccol[Ultim] := CrrCol; Viz[CrrLin+1][CrrCol] := 1; end;
        if(ValBit(A[CrrLin][CrrCol], 0)=0) and (Viz[CrrLin][CrrCol-1]=0) then
            begin inc(Ultim); Clin[Ultim] := CrrLin; Ccol[Ultim] := CrrCol-1; Viz[CrrLin][CrrCol-1] := 1; end;
    end;
end;

begin
	assign(Fin, InFile);
	reset(Fin);
	Svf := 0; AriaMax:=0;
    {citire}
    readln(Fin, C);
    readln(Fin, N);
    for i:=1 to N do
        for j:=1 to N do begin
            read(Fin, A[i][j]);
            if(A[i][j] = 9) or (A[i][j] = 11) or (A[i][j] = 15) or (A[i][j] = 13) then begin
                inc(Svf); Slin[Svf] := i; Scol[Svf] := j;
            end;
         end;
    close(Fin);

    {initializare}
    for i:=0 to N+1 do begin
         Viz[0][i] := 15;  Viz[N+1][i] := 15;
         Viz[i][0] := 15;  Viz[i][N+1] := 15;
    end;
     for i:=1 to N do
        for j:=1 to N do Viz[i][j] := 0;
    {rezolvare}
    NrCamere := Svf;
    while(Svf>0) do begin
        s_lin := Slin[Svf]; s_col := Scol[Svf];
        Fill(s_lin, s_col,Aria, elin, ecol);
        dec(Svf);
        if(Aria>=AriaMax) then begin maxil := s_lin; maxic := s_col; maxfl := elin; maxfc := ecol; AriaMax := Aria; end;
    end;

    assign(Fou,OutFile);
    rewrite(Fou);
    if C = 1 then writeln(Fou,NrCamere);
    if C = 2 then writeln(Fou,AriaMax);
    if C = 3 then writeln(Fou, maxil,' ',maxic,' ',maxfl,' ',maxfc);
    close(Fou);
end.
