/*
    Solutie O(n^6)
    prof. Constantin Galatan
*/
#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("fadema.in");
ofstream fout("fadema.out");

const int MaxN = 1001;
short a[MaxN][MaxN];
short L[MaxN];

int n, m;
int nmax;

int main()
{
    fin >> n >> m;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            fin >> a[i][j];

    for (int i1 = 0; i1 < n; i1++)
        for (int i2 = i1; i2 < n; i2++)
            for (int j1 = 0; j1 < m; ++j1)
                for (int j2 = j1; j2 < m; ++j2)
                {
                    bool ok = true;
                    for (int i = i1; i <= i2 && ok; ++i)
                        for (int j = j1; j <= j2 && ok; ++j)
                            if ((j < j2 && a[i][j] == a[i][j + 1]) ||
                                (i > i1 && a[i][j] == a[i - 1][j]))
                            {
                                ok = false;
                            }
                     if (ok)
                        nmax = max(nmax, (i2 - i1 + 1) * (j2 - j1 + 1));
                }



    fout << nmax;
    fin.close();
    fout.close();
}
