#include <bits/stdc++.h>
using namespace std;
const int MAXX = 1e5;

vector<int64_t> solveSlow(vector<int> t, vector<int> p, int T) {
    int64_t time = 0;
    int n = t.size();

    vector<int> wait(MAXX + 1, 0);
    vector<int> food;
    
    map<int, vector<int>> orders;
    map<int, vector<int64_t>> answers;
    
    for(int i = 0; i < n; ++i)
        orders[p[i]].push_back(i);
    
    int rem = n;

    while(rem) { 
        for(int i = 0; i < n; ++i) {
            if(t[i] == time) {
                food.push_back(-T);
                wait[p[i]] += 1;
            }
        }

        vector<int> redo;
        for(auto& elem : food) {
            if(elem >= 0 and wait[elem] > 0) {
                wait[elem] -= 1;
                rem -= 1;
                answers[elem].push_back(time);
            } else {
                redo.push_back(elem + 1);
            }
        }
        food = redo;
        time += 1;
    }
    
    vector<int64_t> sol(n, 0);

    for(auto elem : orders) {
        int who = elem.first;
        for(int i = 0; i < int(orders[who].size()); ++i) {
            sol[orders[who][i]] = answers[who][i];
        }
    }

    return sol;
}

int main() {
    ifstream cin("ramen.in");
    ofstream cout("ramen.out");

    int n, T; cin >> n >> T;
    vector<int> t(n, 0), p(n, 0);
    for(int i = 0; i < n; ++i) {
        cin >> t[i] >> p[i];
    }

    auto sol = solveSlow(t, p, T);
    for(auto temp : sol)
        cout << temp << "\n";
}
